using BarContracts.BindingModels;
using BarContracts.ViewModels;
using BarDataModels.Models;

namespace BarListImplement.Models
{
    public class Implementer : IImplementerModel
    {
        public int Id { get; private set; }

        public string ImplementerFIO { get; private set; } = string.Empty;

        public string Password { get; private set; } = string.Empty;

        public int WorkExperience { get; private set; }

        public int Qualification { get; private set; }

        public static Implementer? Create(ImplementerBindingModel Model)
        {
            if (Model == null)
            {
                return null;
            }
            return new()
            {
                Id = Model.Id,
                Password = Model.Password,
                Qualification = Model.Qualification,
                ImplementerFIO = Model.ImplementerFIO,
                WorkExperience = Model.WorkExperience,
            };
        }

        public void Update(ImplementerBindingModel Model)
        {
            if (Model == null)
                return;
            
            Password = Model.Password;
            Qualification = Model.Qualification;
            ImplementerFIO = Model.ImplementerFIO;
            WorkExperience = Model.WorkExperience;
        }

        public ImplementerViewModel GetViewModel => new()
        {
            Id = Id,
            Password = Password,
            Qualification = Qualification,
            ImplementerFIO = ImplementerFIO,
        };
    }
}
